package com.b510.album.enhance;

import java.sql.SQLException;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.springframework.orm.hibernate3.HibernateCallback;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

public class HongtenHibernateDaoSupport extends HibernateDaoSupport {
	/**
	 * ʹhql зҳѯ
	 * 
	 * @param hql
	 *            Ҫѯhql
	 * @param offset
	 *            һ¼
	 * @param pageSize
	 *            ÿҳҪʾļ¼
	 * @return ǰҳм¼
	 */
	public List findByPage(final String hql, final int offset,
			final int pageSize) {
		List list = getHibernateTemplate().executeFind(new HibernateCallback() {
			public Object doInHibernate(Session session)
					throws HibernateException, SQLException {
				List result = session.createQuery(hql).setFirstResult(offset)
						.setMaxResults(pageSize).list();
				return result;
			}
		});
		return list;
	}

	/**
	 * ʹhql зҳѯ
	 * 
	 * @param hql
	 *            Ҫѯhql
	 * @param value
	 *            hqlһҪ룬valueǴĲ
	 * @param offset
	 *            һ¼
	 * @param pageSize
	 *            ÿҳҪʾļ¼
	 * @return ǰҳм¼
	 */
	public List findByPage(final String hql, final Object value,
			final int offset, final int pageSize) {
		List list = getHibernateTemplate().executeFind(new HibernateCallback() {
			public Object doInHibernate(Session session)
					throws HibernateException, SQLException {
				List result = session.createQuery(hql).setParameter(0, value)
						.setFirstResult(offset).setMaxResults(pageSize).list();
				return result;
			}
		});
		return list;
	}

	/**
	 * ʹhql зҳѯ
	 * 
	 * @param hql
	 *            Ҫѯhql
	 * @param values
	 *            hqlжҪ룬valuesǴĲ
	 * @param offset
	 *            һ¼
	 * @param pageSize
	 *            ÿҳҪʾļ¼
	 * @return ǰҳм¼
	 */
	public List findByPage(final String hql, final Object[] values,
			final int offset, final int pageSize) {
		List list = getHibernateTemplate().executeFind(new HibernateCallback() {
			public Object doInHibernate(Session session)
					throws HibernateException, SQLException {
				Query query = session.createQuery(hql);
				for (int i = 0; i < values.length; i++) {
					query.setParameter(i, values[i]);
				}
				List result = query.setFirstResult(offset).setMaxResults(
						pageSize).list();
				return result;
			}
		});
		return list;
	}
}